import 'antd/es/form/style/css';
import _Form from 'antd/es/form';
import React, { createContext, useState, Children, cloneElement } from 'react';
import { isValidElementType } from 'react-is';
import PropTypes from 'prop-types';

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var FormContext = createContext({});

function isComponent(type) {
  return isValidElementType(type) && typeof type !== 'string';
}
function isFunction(arg) {
  return typeof arg === 'function';
}

var Form = function Form(_ref) {
  var children = _ref.children,
      formProps = _objectWithoutProperties(_ref, ["children"]);

  var _useState = useState({}),
      _useState2 = _slicedToArray(_useState, 2),
      params = _useState2[0],
      setParams = _useState2[1];

  var _useState3 = useState({}),
      _useState4 = _slicedToArray(_useState3, 2),
      registers = _useState4[0],
      setRigisters = _useState4[1];

  var _useState5 = useState({}),
      _useState6 = _slicedToArray(_useState5, 2),
      defaultState = _useState6[0],
      setDefaultState = _useState6[1];

  var _useState7 = useState([]),
      _useState8 = _slicedToArray(_useState7, 2),
      defaultErrors = _useState8[0],
      setDefaultErrors = _useState8[1];

  var _useState9 = useState([]),
      _useState10 = _slicedToArray(_useState9, 2),
      errors = _useState10[0],
      setErrors = _useState10[1];

  var _useState11 = useState(false),
      _useState12 = _slicedToArray(_useState11, 2),
      invalid = _useState12[0],
      setInvalid = _useState12[1];

  var $setParams = function $setParams($name, $value) {
    setParams(Object.assign(params, _defineProperty({}, $name, $value)));
  };

  var $setRegisters = function $setRegisters($name, $value) {
    if (registers[$name]) {
      console.warn("".concat($name, " has ever been registed!"));
      return;
    }

    setRigisters(Object.assign(registers, _defineProperty({}, $name, $value ? $value : null)));
  };

  var $setDefaultState = function $setDefaultState($name, $value) {
    setDefaultState(Object.assign(defaultState, _defineProperty({}, $name, $value)));
  };

  var $setErrors = function $setErrors($name, $value) {
    setInvalid(true);
    setErrors(Object.assign(errors, _defineProperty({}, $name, $value)));
  };

  var $checkInvalid = function $checkInvalid(errors, $name) {
    var errorArray = Object.entries(errors).filter(function (item) {
      return item[1];
    });
    return errorArray.length === 0 || errorArray.length === 1 && errorArray[0][0] === $name ? false : true;
  };

  var $removeError = function $removeError($name) {
    setInvalid($checkInvalid(errors, $name));
    setErrors(Object.assign(errors, _defineProperty({}, $name, null)));
  };

  var $reset = function $reset($name) {
    if (typeof $name === "string") {
      $setParams($name, defaultState[$name]);
      registers[$name].$setValue(defaultState[$name]);
      registers[$name].$setFocus(false);
      $setErrors($name, defaultErrors[$name]);
      var others = Object.assign({}, errors);
      others[$name] = null;

      if (defaultErrors[$name] || Object.values(others).filter(function (item) {
        return !!item;
      }).length > 0) {
        setInvalid(true);
        return;
      } else {
        setInvalid(false);
        return;
      }
    }

    Object.entries(defaultState).filter(function (item) {
      return item[1] !== undefined;
    }).forEach(function (item) {
      $setParams(item[0], item[1]);
    });
    Object.entries(defaultState).forEach(function (item) {
      registers[item[0]].$setValue(item[1]);
      registers[item[0]].$setFocus(false);
    });
    setErrors(defaultErrors);
    var errorArray = Object.values(defaultErrors).filter(function (item) {
      return !!item;
    });

    if (errorArray.length > 0) {
      setInvalid(true);
    } else {
      setInvalid(false);
    }
  };

  var $getField = function $getField($name) {
    if (!registers[$name]) {
      console.log("".concat($name, " is not exist"));
      return;
    }

    return registers[$name];
  };

  var $getFirstError = function $getFirstError() {
    var errorArray = Object.values(errors).filter(function (item) {
      return !!item;
    });

    if (errorArray && errorArray.length > 0) {
      return errorArray[0];
    }

    return;
  };

  var $setDefaultErrors = function $setDefaultErrors($name, $error) {
    setDefaultErrors(Object.assign(defaultErrors, _defineProperty({}, $name, $error)));
  };

  var $form = {
    $params: params,
    $setParams: $setParams,
    $registers: registers,
    $setRegisters: $setRegisters,
    $defaultState: defaultState,
    $setDefaultState: $setDefaultState,
    $valid: !invalid,
    $invalid: invalid,
    $setErrors: $setErrors,
    $removeError: $removeError,
    $errors: errors,
    $reset: $reset,
    $getField: $getField,
    $getFirstError: $getFirstError,
    $setDefaultErrors: $setDefaultErrors
  };

  function _render() {
    var restForm = _objectWithoutProperties($form, ["$registers", "$setErrors", "$removeError", "$setRegisters", "$setDefaultState", "$defaultState", "$setParams"]);

    if (isFunction(children)) {
      return children(restForm);
    }

    return Children.map(children, function (child) {
      return child && isComponent(child.type) ? cloneElement(child, {
        $form: restForm
      }) : child;
    });
  }

  return React.createElement(FormContext.Provider, {
    value: $form
  }, React.createElement(_Form, formProps, _render()));
};

Form.propTypes = {
  children: PropTypes.any,
  hideRequiredMark: PropTypes.bool,
  labelAlign: PropTypes.oneOf(["left", "right"]).isRequired,
  layout: PropTypes.oneOf(["horizontal", "vertical", "inline"]).isRequired,
  colon: PropTypes.bool.isRequired,
  labelCol: PropTypes.object,
  wrapperCol: PropTypes.object
};
Form.defaultProps = {
  hideRequiredMark: false,
  labelAlign: "right",
  layout: "horizontal",
  colon: true
};

var defaultProps = {
  changePropName: "onChange",
  valuePropName: "value",
  $parser: function $parser(value) {
    return typeof value === "string" ? value.trim() : value;
  }
};
function parserProps(props, context) {
  var _Object$assign5;

  var $setDefaultState = context.$setDefaultState,
      $setParams = context.$setParams,
      $setErrors = context.$setErrors,
      $removeError = context.$removeError,
      $registers = context.$registers,
      $setRegisters = context.$setRegisters,
      $setDefaultErrors = context.$setDefaultErrors,
      _$reset = context.$reset;

  var name = props.name,
      required = props.required,
      $onChange = props.$onChange,
      $defaultValue = props.$defaultValue,
      $value = props.$value,
      $setValue = props.$setValue,
      $focus = props.$focus,
      $setFocus = props.$setFocus,
      $defaultChecked = props.$defaultChecked,
      $formatter = props.$formatter,
      $parser = props.$parser,
      $validators = props.$validators,
      validMessage = props.validMessage,
      children = props.children,
      changePropName = props.changePropName,
      valuePropName = props.valuePropName,
      rest = _objectWithoutProperties(props, ["name", "required", "$onChange", "$defaultValue", "$value", "$setValue", "$focus", "$setFocus", "$defaultChecked", "$formatter", "$parser", "$validators", "validMessage", "children", "changePropName", "valuePropName"]);

  var filedProps;
  var isRequired = required === undefined || required === false ? false : true;

  var $getValidResult = function $getValidResult($value) {
    return $validators && $focus ? isFunction($validators) ? $validators($value) === true ? undefined : $validators($value) : console.error("$validators need a type of function") : undefined;
  };

  var onChange = function onChange(ev) {
    var value = ev && ev.target ? ev.target[valuePropName] : ev;
    var parserValue = $parser ? $parser(value) : value;
    var $validResult = $getValidResult(value);
    var isRequirdError = isRequired && !value && value !== 0;
    $setParams(name, parserValue);
    $setValue(value);
    !$focus && $setFocus(true);
    $validResult || isRequirdError ? $setErrors(name, $validResult || validMessage || "".concat(name, " is required")) : $removeError(name);
    children(filedProps);

    if ($onChange) {
      $onChange(parserValue);
    }
  };

  if (!$registers[name] && !!valuePropName) {
    $setRegisters(name, {
      $setValue: $setValue,
      $setFocus: $setFocus,
      $reset: function $reset() {
        return _$reset(name);
      }
    });

    if ($defaultValue) {
      $setParams(name, $parser ? $parser($defaultValue) : $defaultValue);
      var checkRequiredNotPass = isRequired && $defaultValue !== undefined && $defaultValue !== 0 && $defaultValue !== "" && $defaultValue !== false && $defaultValue !== null && !$defaultValue;

      if ($formatter) {
        $setValue($formatter($defaultValue));
        $setDefaultState(name, $formatter($defaultValue));

        if ($getValidResult($formatter($defaultValue)) || checkRequiredNotPass) {
          var validMsg = $getValidResult($formatter($defaultValue)) || validMessage;
          $setErrors(name, validMsg);
          $setDefaultErrors(name, validMsg);
        } else {
          $removeError(name);
        }

        Object.assign(rest, _defineProperty({}, valuePropName, $formatter($defaultValue)));
      } else {
        $setValue($defaultValue);
        $setDefaultState(name, $defaultValue);

        if ($getValidResult($defaultValue) || checkRequiredNotPass) {
          var _validMsg = $getValidResult($defaultValue) || validMessage;

          $setErrors(name, _validMsg);
          $setDefaultErrors(name, _validMsg);
        } else {
          $removeError(name);
        }

        Object.assign(rest, _defineProperty({}, valuePropName, $defaultValue));
      }
    } else {
      if ($formatter) {
        $setValue($formatter($value));
        $setDefaultState(name, $formatter($value));

        if ($getValidResult($formatter($value)) || isRequired) {
          var _validMsg2 = $getValidResult($formatter($value)) || validMessage;

          $setErrors(name, _validMsg2);
          $setDefaultErrors(name, _validMsg2);
        } else {
          $removeError(name);
        }

        Object.assign(rest, _defineProperty({}, valuePropName, $formatter($value)));
      } else {
        $setDefaultState(name, $value);

        if ($getValidResult($value) || isRequired) {
          var _validMsg3 = $getValidResult($value) || validMessage || "".concat(name, " is required");

          $setErrors(name, _validMsg3);
          $setDefaultErrors(name, _validMsg3);
        } else {
          $removeError(name);
        }

        Object.assign(rest, _defineProperty({}, valuePropName, $value));
      }
    }
  }

  Object.assign(rest, (_Object$assign5 = {}, _defineProperty(_Object$assign5, changePropName, onChange), _defineProperty(_Object$assign5, "_TYPE_", valuePropName), _Object$assign5));
  filedProps = rest;
  return children(filedProps);
}

var Field = function Field(props) {
  var children = props.children;
  return React.createElement(FormContext.Consumer, null, function (context) {
    if (isFunction(children)) {
      return parserProps(props, context);
    }
  });
};

Field.propTypes = {
  name: PropTypes.string.isRequired,
  $defaultValue: PropTypes.any,
  $onChange: PropTypes.func,
  $formatter: PropTypes.func,
  $parser: PropTypes.func,
  valuePropName: PropTypes.string,
  changePropName: PropTypes.string,
  children: PropTypes.any,
  $form: PropTypes.object
};
Field.defaultProps = defaultProps;

var FormItem = function FormItem(_ref) {
  var _children = _ref.children,
      $validators = _ref.$validators,
      itemProps = _ref.itemProps,
      fieldProps = _objectWithoutProperties(_ref, ["children", "$validators", "itemProps"]);

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      $value = _useState2[0],
      $setValue = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      $focus = _useState4[0],
      $setFocus = _useState4[1];

  var getChildType = function getChildType() {
    var childType = _children.type;

    if (typeof childType === "function") {
      return childType.name;
    }

    if (typeof childType === "string") {
      return childType;
    }
  };

  var childType = getChildType();

  if (childType === "Checkbox" || childType === "Radio" || childType === "Switch") {
    fieldProps.valuePropName = "checked";
  }

  if (childType === "Transfer") {
    fieldProps.valuePropName = "selectedKeys";
  }

  if (childType === "Upload") {
    fieldProps.valuePropName = null;
  }

  var isRequired = fieldProps.required === undefined || fieldProps.required === false ? false : true;
  var $validResult = $validators && $focus ? isFunction($validators) ? $validators($value) === true ? undefined : $validators($value) : console.error("$validators need a type of function") : undefined;
  var isShowHelp = (isRequired && !$value || $validResult) && $focus;
  return React.createElement(Field, Object.assign({
    $value: $value,
    $setValue: $setValue,
    $focus: $focus,
    $setFocus: $setFocus
  }, fieldProps, {
    children: function children(fieldHandleProps) {
      var _TYPE_ = fieldHandleProps._TYPE_,
          childProps = _objectWithoutProperties(fieldHandleProps, ["_TYPE_"]);

      return React.createElement(_Form.Item, Object.assign({
        required: isRequired,
        validateStatus: $focus && isShowHelp ? "error" : undefined,
        help: isShowHelp && React.createElement("span", {
          style: {
            color: "red"
          }
        }, $validResult || fieldProps.validMessage || "required")
      }, itemProps), cloneElement(_children, _defineProperty({
        onChange: childProps.onChange
      }, _TYPE_, $value)));
    }
  }));
};

FormItem.propTypes = {
  required: PropTypes.bool,
  name: PropTypes.string.isRequired,
  $defaultValue: PropTypes.any,
  $onChange: PropTypes.func,
  $formatter: PropTypes.func,
  $parser: PropTypes.func,
  valuePropName: PropTypes.string,
  changePropName: PropTypes.string,
  children: PropTypes.element.isRequired,
  validMessage: PropTypes.string,
  $validators: PropTypes.func,
  itemProps: PropTypes.shape({
    label: PropTypes.string,
    colon: PropTypes.bool,
    extra: PropTypes.string,
    labelCol: PropTypes.object,
    wrapperCol: PropTypes.object,
    labelAlign: PropTypes.oneOf(["left", "right"])
  })
};

var withForm = function withForm(WrappedComponent, config) {
  return function (props) {
    var others = Object.assign({}, props);
    ["hideRequiredMark", "labelAlign", "layout", "colon", "labelCol", "wrapperCol"].forEach(function (prop) {
      if (prop in others) {
        Object.assign(config, _defineProperty({}, prop, others[prop]));
      }

      delete others[prop];
    });
    return React.createElement(Form, config, function ($form) {
      return React.createElement(WrappedComponent, Object.assign({
        $form: $form
      }, others));
    });
  };
};

withForm.propTypes = {
  WrappedComponent: PropTypes.any.isRequired,
  config: PropTypes.shape({
    hideRequiredMark: PropTypes.bool,
    labelAlign: PropTypes.oneOf(["left", "right"]).isRequired,
    layout: PropTypes.oneOf(["horizontal", "vertical", "inline"]).isRequired,
    colon: PropTypes.bool.isRequired,
    labelCol: PropTypes.object,
    wrapperCol: PropTypes.object
  })
};
withForm.defaultProps = {
  config: {
    hideRequiredMark: false,
    labelAlign: "right",
    layout: "horizontal",
    colon: true
  }
};

export { Form, FormItem, withForm };
//# sourceMappingURL=antd-better-form.es.development.js.map
