import React, { FC } from "react";

export declare interface FromProps {
  children: any;
  hideRequiredMark?: boolean;
  labelAlign?: "left" | "right";
  labelCol?: any;
  wrapperCol?: any;
  layout?: "horizontal" | "vertical" | "inline";
  colon?: boolean;
}

export interface ItemProps {
  label?: string;
  colon?: boolean;
  extra?: string | React.ReactElement;
  labelCol?: any;
  wrapperCol?: any;
  labelAlign?: "left" | "right";
}

export declare interface FormItemProps {
  required?: boolean;
  name: string;
  $defaultValue?: any;
  $onChange?: (value?) => void;
  $formatter?: (value?) => any;
  $parser?: (value?) => any;
  valuePropName?: string;
  changePropName?: string;
  children: any;
  validMessage?: string;
  $validators?: (value?) => any;
  itemProps?: ItemProps;
}

export function Form(props: FromProps): React.ReactComponentElement;

export function FormItem(props: FormItemProps): React.ReactComponentElement;

export function withForm<SelfProps = any, FormProps = FromProps>(
  component: React.ComponentType<
    SelfProps & {
      $form: FormProps;
    }
  >,
  config?: FormProps
): React.FunctionComponentElement<FormProps>;
